-- fptr.e
-- Call functions via pointers
-- Matt Lewis
-- 3/26/01
-- matthewwalkerlewis@yahoo.com

include machine.e
include misc.e
without trace
without warning
constant
fptr_asm = {
    #60,                    --    0: pusha
    #BB,#00,#00,#00,#00,    --    1: mov ebx, paramcount (2)
    #B9,#00,#00,#00,#00,    --    6: mov ecx, params (7)
                            --    B: start: 
    #8B,#01,                --    B: mov eax, [ecx]
    #50,                    --    D: push eax
    #83,#C1,#04,            --    E: add ecx, 4
    #4B,                    --   11: dec ebx
    #75,#F7,                --   12: jnz start
    #FF,#15,#00,#00,#00,#00,--   14: call dword ptr [comfunc] (22)
    #A3,#00,#00,#00,#00,--   1A: mov [retpointer], eax (27)
    #61,                    --   20: popa
    #C3},                   --   21: ret


fptr_paramcount = 2,
fptr_params = 7,
fptr_funcptr = 22+0,
fptr_retptr = 27+0,
retval = allocate(4),

fptr_asm_addr = allocate( length( fptr_asm ) + 20 * 4 )

constant
fptr_func = fptr_asm_addr + 33,
fptr_retval = fptr_asm_addr + 37,
fptr_param_ptr = fptr_asm_addr + 41

poke( fptr_asm_addr, fptr_asm )
poke4( fptr_asm_addr + fptr_funcptr, fptr_func )
poke4( fptr_asm_addr + fptr_params, fptr_param_ptr )
poke4( fptr_asm_addr + fptr_retptr, fptr_retval )

with trace
global function call_fptr( atom fptr, sequence params )
    atom ret
    
    -- store the pointer to the function
    poke4( fptr_func, fptr )

    -- reverse the params for stdcall calling convention
    params = reverse(params)

    -- store the params
    poke4( fptr_param_ptr, params )

    -- tell the asm how many params to push
    poke4( fptr_asm_addr + fptr_paramcount, length(params) )
    -- run the asm
    call( fptr_asm_addr )

    -- get the value returned from the function
    ret = peek4u( fptr_retval )
    
    return ret
end function
without trace

constant 
func_asm = {

    #55,                    --    0: push ebp
    #89,#E5,                --    1: mov ebp, esp
    #51,                    --    3: push ecx
    #B9,#00,#00,#00,#00,    --    4: mov ecx, argnum (5)
    #89,#E6,                --    9: mov esi, esp
    #83,#C6,#0C,            --    B: add esi, 12
    #BF,#00,#00,#00,#00,    --    E: mov edi, myargs (15)
    #F3,#A5,                --   13: rep movsd; next we call the proc

    #FF,#15,#00,#00,#00,#00,--   15: call dword ptr [pfunc] (#17)

    #59,                    --   1B: pop ecx
    #89,#EC,                --   1C: mov esp, ebp
    #5D,                    --   1E: pop ebp
    #C2,#00,#00,#00,#00}    --   1F: ret [argnum] (#20)


--    #51,                    --    0: push ecx
--    #B9,#00,#00,#00,#00,    --    1: mov ecx, argnum (#02)
--    #89,#E6,                --    6: mov esi, esp
--    #83,#C6,#08,            --    8: add esi, 28
--    #BF,#00,#00,#00,#00,    --    B: mov edi, myargs (#0C)
--    #F3,#A5,                --   10: rep movsd; next we call the proc

--    #FF,#15,#00,#00,#00,#00,--   12: call dword ptr [pfunc] (#14)

--    #59,                    --   18: pop ecx
--    #A3,#00,#00,#00,#00,    --   19: mov [retval], eax (#1A)
--    #58,                    --   1E: pop eax
--    #A3,#00,#00,#00,#00,    --   1F: mov [@retval + 4], eax (#20)
--    #89,#0D,#00,#00,#00,#00,--   24: mov [@retval + 8], ecx (#26)
--    #B9,#00,#00,#00,#00,    --   2A: mov ecx, argnum (#2B)
                            --   2F: poploop:
--    #58,                    --   2F: pop eax; get rid of the arguments
--    #49,                    --   30: dec ecx
--    #75,#FC,                --   31: jnz poploop
--    #8B,#0D,#00,#00,#00,#00,--   33: mov ecx, [@retval+8](#35); restore ecx
--    #A1,#00,#00,#00,#00,    --   39: mov eax, [@retval+4](#3A); get the return addr
--    #50,                    --   3E: push eax; put the return addr on the stack
--    #A1,#00,#00,#00,#00,    --   3F: mov eax, [@retval] (#40)
--    #53,#00,#00,#00,#00}    --   44: ret [argnum] (#45)

constant offset = length( func_asm )

global function new_pfunc( atom callback, integer args )
    atom func_addr, func_retval, func_pfunc, func_args
    
    func_addr = allocate( length(func_asm) + 4 * 12  )
    poke( func_addr, func_asm )
    func_retval = func_addr + offset
    func_pfunc = func_retval + 4
    func_args = func_pfunc + 4
    
    poke4( func_addr + #05, args )
    poke4( func_addr + #0F, func_args )
    poke4( func_addr + #17, func_pfunc )
    poke4( func_addr + #20, ( args + 0 ) * 4 )
    
    poke4( func_pfunc, callback )
    
    return { func_addr, func_args }
end function


